Bash 脚本进阶,经典用法及其案例美高梅手机登录

作者:电脑系统

生龙活虎、条件接受、判别

1、9x9乘法表

#!/bin/bash
for a in {1..9};do
        for b in `seq 1 $a`;do
                let c=$a*$b ;echo -e "${a}x${b}=$ctc"
        done
        echo    
done

 美高梅手机登录网站 1

 

1、循环调整语句

(1)语法

continue [N]:提前停止第N层的本轮巡回,而直白走入下豆蔻梢头轮剖断;最内层为第1层

break [N]:提前结束第N层循环,最内侧为第1层

 例:while CONDTITON1; do

  CMD1

if CONDITION2; then

  continue / break

fi

  CMD2

done

 

(2)案例:

① 求(1 3 ... 49 53 ... 100)的和

#!/bin/bash
sum=0
for i in {1..100} ;do
        [ $i -eq 51 ] && continue
        [ $[$i%2] -eq 1 ] && { let sum =i;let i  ; }
done
echo sum=$sum

 分析:做1 2 ... 100的大循环,当i=51时,跳过此番巡回,不过后续全方位循环,结果为:sum=2449

 ② 求(1 3 ... 49)的和

#!/bin/bash
sum=0
for i in {1..100} ;do
        [ $i -eq 51 ] && break
        [ $[$i%2] -eq 1 ] && { let sum =i;let i  ; }
done
echo sum=$sum

 深入分析:做1 2 ... 100的巡回,当i=51时,跳出整个循环,结果为:sum=625

 

1、条件选取if

(1)用法格式

if 判别规范 1 ; then

  条件为实在分支代码

elif 推断规范 2 ; then

  条件为真正分支代码

elif 推断规范 3 ; then

  条件为确实分支代码

else

  以上规范都为假的道岔代码

fi

逐一件进行决断,第一回遇为“真”条件时,实施其分支,而后甘休全数if。

 

(2)优秀案例:

① 剖断年纪

#!/bin/bash
read -p "Please input your age: " age
if [[ $age =~ [^0-9] ]] ;then
    echo "please input a int"
    exit 10
elif [ $age -ge 150 ];then
    echo "your age is wrong"
    exit 20
elif [ $age -gt 18 ];then
    echo "good good work,day day up"
else
    echo "good good study,day day up"
fi

 分析:请输入年纪,先判别输入的是否含有除数字以外的字符,有,就报错;未有,继续判定是或不是低于150,是或不是超越18。

② 决断分数

#!/bin/bash
read -p "Please input your score: " score
if [[ $score =~ [^0-9] ]] ;then
    echo "please input a int"
    exit 10
elif [ $score -gt 100 ];then
    echo "Your score is wrong"
    exit 20
elif [ $score -ge 85 ];then
    echo "Your score is very good"
elif [ $score -ge 60 ];then
    echo "Your score is soso"
else
    echo "You are loser"
fi

 深入分析:请输入战绩,先判别输入的是还是不是含有除数字以外的字符,有,就报错;未有,继续剖断是还是不是超出100,是不是超过85,是或不是超出60。

 

2、条件推断 case

(1)用法格式

case $name in;

PART1)

  cmd

  ;;

PART2)

  cmd

  ;;

*)

  cmd

  ;;

esac

细心:case 扶持glob 风格的通配符:

  *: 任性长度大肆字符

  ?: 自便单个字符

  [] :钦定范围内的大肆单个字符

  a|b: a 或b

 

(2)案例:

判断yes or no

#!/bin/bash
read -p "Please input yes or no: " anw
case $anw in
[yY][eE][sS]|[yY])
    echo yes
    ;;
[nN][oO]|[nN])
    echo no
    ;;
*)
    echo false
    ;;
esac

 解析:请输入yes or no,回答Y/y、yes各个大小写组合为yes;回答N/n、No种种大小写组合为no。

 

3、until 循环

(1)用法

unitl 循环条件 ;do

  循环

done

进去法规:循环条件为true ;退出标准:循环条件为false;正好和while相反,所以临时用,用while就能够。

 

(2)案例

监察和控制xiaoming顾客,登入就杀死

until pgrep -u xiaoming &> /dev/null ;do
        sleep 0.5
done
pkill -9 -u xiaoming

 解析:每间隔0.5秒扫描,直到发现xiaoming客户登陆,杀死那个进度,退出脚本,用于监察和控制顾客登入。

 

六、共享多少个有趣的小本子

 

前言:在linux中,Bash脚本是很底子的知识,大家莫不豆蔻梢头听脚本以为很庞大上,像笔者当初刚伊始学同样,感觉会写脚本的都以大神。尽管错综相连的脚本是很烧脑,然而,当我们熟识的支配了中间的用法与技艺,再多加练习,总有一天也会成为一箭穿心的脚本大神。脚本在坐褥中的成效,想必作者小编不说,我们也都清楚,脚本写的6,能够省下众多深根固柢的操作,减轻自身的劳作压力。好了,废话没有多少说,接下去,正是Bash脚本的用法体现。

1、用法格式

trap ' 触发指令' 非时限信号,自定义进度收到系统发生的钦命复信号后,将推行触发指令,而不会实行原操作

trap '' 时限信号,忽视复信号的操作

trap '-' 频限信号,恢复生机原能量信号的操作

trap -p,列出自定义时限信号操作

连续信号能够3种表明方法:信号的数字2、全名SIGINT、缩写INT

 

二、多少个循环

4、select 循环与菜单

(1)用法

select variable in list

do

  循环体命令

done

① select 循环首要用来创设菜单,按数字顺序排列的示菜单项将显示在正规错误上,并出示PS3 指示符,等待客户输入

② 客商输入菜单列表中的有个别数字,试行相应的吩咐

③ 客商输入被保存在内置变量 REPLY 中

④ select 是个非常循环,由此要铭记在心用 break 命令退出循环,或用 exit 按 命令终止脚本。也得以按 ctrl c退出循环

⑤ select 和 经常和 case 联合利用

⑥ 与for循环相近,可以回顾 in list, 那时候利用地点参量

 

(2)案例:

扭转菜单,并显示选中的价位

PS3="Please choose the menu: "
select menu in mifan huimian jiaozi babaozhou quit
do
        case $REPLY in
        1|4)
                echo "the price is 15"
                ;;
        2|3)
                echo "the price is 20"
                ;;
        5)
                break
                ;;
        *)
                echo "no the option"
        esac
done

 解析:PS3是select的提醒符,自动生成菜单,选择5break退出循环。

美高梅手机登录网站 2

 

1、for

(1)用法格式

① for name in 列表 ;do

  循环体

done

for (( exp1; exp2; exp3 )) ;do

  cmd

done

美高梅手机登录网站 3

exp1只举办一次,约等于在for里嵌了while 

③ 推行机制:依次将列表中的成分赋值给“变量名”; 每回赋值后即进行一回循环体; 直到列表中的成分耗尽,循环截止

列表的象征方法,能够glob 通配符,如{1..10} 、*.sh ;也足以变量援引,如: `seq 1 $name`

 

(2)案例

① 求出(1 2 ... n)的总和

sum=0
read -p "Please input a positive integer: " num
if [[ $num =~ [^0-9] ]] ;then
    echo "input error"
elif [[ $num -eq 0 ]] ;then
    echo "input error"
else
    for i in `seq 1 $num` ;do
        sum=$[$sum $i]
    done
    echo $sum
fi
unset zhi   

 深入分析:sum开端值为0,请输入二个数,先判定输入的是还是不是含有除数字以外的字符,有,就报错;未有看清是不是为0,不为0进来for循环,i的约束为1~输入的数,每一回的循环为sum=sum i,循环甘休,最后输出sum的值。

② 求出(1 2 ... 100)的总和

for (( i=1,num=0;i<=100;i   ));do
        [ $[i%2] -eq 1 ] && let sum =i
done
echo sum=$sum

 分析:i=1,num=0;当i<=100,步向循环,若i÷2取余=1,则sum=sum i,i=i 1。

 

3、国际象棋棋盘

#!/bin/bash
red="\033[1;41m  \033[0m"
yellow="\033[1;43m  \033[0m"

for i in {1..8};do
        if [ $[i%2] -eq 0 ];then
                for i in {1..4};do
                        echo -e -n "$red$yellow";
                done
                echo
        else
                for i in {1..4};do
                        echo -e -n "$yellow$red";
                done
                echo 
        fi
done

 美高梅手机登录网站 4

 

 好了,几日前的剧情就到这里了,其实作者的剧本根底也是小白级其他,我们一块儿全力,争取进级为脚本大神!!!

 

五、脚本小知识(持续更新)

1、生成随机字符 cat /dev/urandom

  生成8个随机大小写字母或数字 cat /dev/urandom |tr -dc [:alnum:] |head -c 8

2、生成随机数 echo $RANDOM

  分明约束 echo $[RANDOM%7] 随机7个数(0-6)

       echo $[$[RANDOM%7] 31] 随机7个数(31-37)

3、echo打字与印刷颜色字

echo -e "\033[31malong\033[0m" 展现深草绿along

echo -e "\033[1;31malong\033[0m" 高亮显示威尼斯红along

echo -e "\033[41malong\033[0m" 彰显背景观为革命的along

echo -e "\033[31;5malong\033[0m" 展现闪烁的金棕along

color=$[$[RANDOM%7] 31]

echo -ne "\033[1;${color};5m*\033[0m" 显示闪烁的随机色along

 

3、案例

① 打字与印刷0-9,ctrl c不能够止住

#!/bin/bash
trap 'echo press ctrl c' 2
for ((i=0;i<10;i  ));do
        sleep 1
        echo $i
done

 分析:i=0,当i<10,每休眠1秒,i 1,捕获2信号,并执行echo press ctrl c

 美高梅手机登录网站 5

② 打字与印刷0-3,ctrl c不能够止住,3从今将来苏醒,能止住

#!/bin/bash
trap '' 2
trap -p
for ((i=0;i<3;i  ));do
        sleep 1
        echo $i
done
trap '-' SIGINT
for ((i=3;i<10;i  ));do
        sleep 1
        echo $i
done

 剖析:i=0,当i<3,每休眠1秒,i 1,捕获2功率信号;i>3时,撤除捕获2时域信号。

美高梅手机登录网站 6

 

3、重临值结果

true 恒久再次来到成功结果

: null command ,什么也不干,重临成功结果

false 永恒再次回到错误结果

创造Infiniti循环

while true ;do

  循环体

done

 

4、循环中可并行实行,使脚本运转越来越快

(1)用法

for name in 列表 ;do

  {

  循环体

  }&

done

wait

 

(2)实例:

查找自身钦点ip(子网掩码为24的)的网段中,UP的ip地址

read -p "Please input network (eg:192.168.0.0): " net
echo $net |egrep -o "<(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])>"
[ $? -eq 0 ] || ( echo "input error";exit 10 )
IP=`echo $net |egrep -o "^([0-9]{1,3}.){3}"`
for i in {1..254};do
        {
        ping -c 1 -w 1 $IP$i &> /dev/null && 
        echo "$IP$i is up" 
        }&

done
wait

 解析:请输入三个IP地址例192.168.37.234,借使格式不是0.0.0.0 则报错退出;精确则步入循环,IP变量的值为192.168.37.  i的约束为1-254,并行ping 192.168.37.1-154,ping通就输出此IP为UP。直到循环停止。

 

2、while

(1)用法格式

while 循环调控标准 ;do

  循环

done

 循环调控标准;步入循环在此之前,先做壹回判定;每三遍巡回之后会重复做判断;条件为“true” ,则实行三次巡回;直到条件测验状态为“false” 终止循环

 

(2)特殊用法(遍历文件的每意气风发行):

while read line; do调整变量起头化

  循环体

done < /PATH/FROM/SOMEFILE

cat /PATH/FROM/SOMEFILE | while read line; do

  循环体

done

次第读取/PATH/FROM/SOMEFILE文件中的每后生可畏行,且将行赋值给变量line

 

(3)案例:

① 100以内部存款和储蓄器有正奇数之和

sum=0
i=1
while [ $i -le 100 ] ;do
if [ $[$i%2] -ne 0 ];then
    let sum =i
    let i  
else
    let i  
fi
done
echo "sum is $sum"

 深入分析:sum伊始值为0,i的早先值为1;请输入三个数,先剖断输入的是还是不是满含除数字以外的字符,有,就报错;没有当i<100时,步入循环,判别i÷2取余 是或不是不为0,不为0时为奇数,sum=sum i,i 1,为0,i 1;循环结束,最终输出sum的值。

 

2、彩色等腰三角形

#!/bin/bash
read -p "Please input a num: " num
if [[ $num =~ [^0-9] ]];then
        echo "input error" 
else
        for i in `seq 1 $num` ;do
                xing=$[2*$i-1]
                for j in `seq 1 $[$num-$i]`;do
                        echo -ne " "
                done
                for k in `seq 1 $xing`;do
                        color=$[$[RANDOM%7] 31]
                        echo -ne "\033[1;${color};5m*\033[0m"
                done
                echo
        done
fi

美高梅手机登录网站 7

 

2、常用功率信号

1卡塔尔(قطر‎ SIGHUP: 无须关闭进程而让其重读配置文件

2卡塔尔(قطر‎ SIGINT: 中止正在运转的历程;也就是Ctrl c

3) SIGQUIT: 相当于ctrl

9卡塔尔(英语:State of Qatar) SIGKILL: 强逼杀死正在运维的进程

15卡塔尔(قطر‎ SIGTERM :终止正在周转的长河(默认为15)

18卡塔尔国 SIGCONT :继续运转

19卡塔尔 SIGSTOP :后台休眠

9 非功率信号,免强杀死,捕获不住

 

三、循环里的豆蔻梢头对用法

2、循环调整shift命令

(1)作用

用来将参数列表list左移钦定次数,最左端的老大参数就从列表中去除,其前面包车型客车参数继续步向循环

(2)案例:

 ① 创立钦点的五个顾客

#!/binbash
if [ $# -eq 0 ] ;then
        echo "Please input a arg(eg:`basename $0` arg1)"
        exit 1
else
        while [ -n "$1" ];do
                useradd $1 &> /dev/null
                shift
        done
fi

 深入分析:如果未有输入参数(参数的总的数量为0),提醒错误并退出;反之,步入循环;若首先个参数不为空字符,则开创以第二个参数为名的顾客,并移除第贰个参数,将紧跟的参数左移作为第三个参数,直到未有第三个参数,退出。

 ② 打字与印刷直角三角形的字符

#!/binbash
while (( $# > 0 ))
do
        echo "$*"
        shift
done

 美高梅手机登录网站 8

四、非时限信号捕获trap

本文由美高梅4858官方网站发布,转载请注明来源

关键词: